diff --git a/meta/recipes-core/glibc/cross-localedef-native_2.20.bb b/meta/recipes-core/glibc/cross-localedef-native_2.20.bb
index 8aaa225..9463702 100644
--- a/meta/recipes-core/glibc/cross-localedef-native_2.20.bb
+++ b/meta/recipes-core/glibc/cross-localedef-native_2.20.bb
@@ -43,7 +43,7 @@ SRCREV_FORMAT = "glibc__localedef"
 S = "${WORKDIR}/git"
 
 EXTRA_OECONF = "--with-glibc=${S}"
-CFLAGS += "-DNOT_IN_libc=1"
+CFLAGS += "-DNOT_IN_libc=1 -fgnu89-inline"
 
 do_configure () {
 	${S}/localedef/configure ${EXTRA_OECONF}
diff --git a/meta/recipes-core/ncurses/ncurses.inc b/meta/recipes-core/ncurses/ncurses.inc
index 10f7dd1..a7a265d 100644
--- a/meta/recipes-core/ncurses/ncurses.inc
+++ b/meta/recipes-core/ncurses/ncurses.inc
@@ -26,7 +26,7 @@ ENABLE_WIDEC ?= "true"
 # _GNU_SOURCE is required for widec stuff and is detected automatically
 # for target objects.  But it must be set manually for native and sdk
 # builds.
-BUILD_CPPFLAGS += "-D_GNU_SOURCE"
+BUILD_CPPFLAGS += "-D_GNU_SOURCE -P"
 
 # natives don't generally look in base_libdir
 base_libdir_class-native = "${libdir}"
diff --git a/meta/recipes-devtools/binutils/binutils_2.24.bb b/meta/recipes-devtools/binutils/binutils_2.24.bb
index 738aaee..3271409 100644
--- a/meta/recipes-devtools/binutils/binutils_2.24.bb
+++ b/meta/recipes-devtools/binutils/binutils_2.24.bb
@@ -14,6 +14,8 @@ EXTRA_OECONF_class-native = "--enable-targets=all \
                              --enable-install-libiberty \
                              --enable-install-libbfd"
 
+BUILD_CFLAGS = "-Wno-error=logical-not-parentheses"
+
 do_install_class-native () {
 	autotools_do_install
 
